import React, { Component } from 'react';
import PropTypes from 'prop-types';

import '../.././datagrid.css';

/* The RowCell component for the grid which will render - RenderRowCell.
* The RenderRowCell render each cell data.
* @type {class}
* */

class RowCell extends Component {

  render() {
    const RenderRowCell = ({ value, styles }) => (
      <div className="table-cell" title={value} style={styles.gridTableCell} >{value}</div>
    );
    return (
      <div className="row">
        <RenderRowCell
          value={this.props.value}
          styles={this.props.styles}
        />
      </div>
    );
  }
}

RowCell.propTypes = {
  styles: PropTypes.object,
  value: PropTypes.string,
};

RowCell.defaultProps = {
  styles: {},
  value: '',
};

export default RowCell;
