import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { getNoOfPages, addUniqueKey } from './utils/CommonUtils';
import './datagrid.css';
import DataGridSection from './components/dataGrid/DataGrid';

/*
 The DataGrid component for the grid which will render - DataGridSection.
 @type {class}
*/
const formattedData = (data) => {
  let allkeys = [];
  data.map((objInArr) => {
    allkeys = allkeys.concat(Object.keys(objInArr));
  });
  // check all arr entries for missing keys
  data.map((objInArr, i) => {
    allkeys.map((key) => {
      if (objInArr[key] === undefined) {
        // the generic value, in this case ''.
        data[i][key] = '';
      }
    });
  });
  return data;
};

class DataGrid extends Component {
  constructor(props) {
    super(props);
    this.state = {
      data: addUniqueKey(this.props.data),
      metaData: this.props.metaData,
      styles: this.props.styles,
      recordsPerPage: this.props.metaData.recordsPerPage,
      indexOfLastRecord: this.props.metaData.recordsPerPage - 1,
      indexOfFirstRecord: 0,
      noOfPages: getNoOfPages(this.props.data, this.props.metaData.recordsPerPage),
    };
  }
  render() {
    const tempData = formattedData(this.props.data);
    return (
      <DataGridSection
        data={tempData}
        metaData={this.props.metaData}
        styles={this.props.styles}
        gridState={this.state}
      />
    );
  }
}

DataGrid.propTypes = {
  data: PropTypes.array,
  metaData: PropTypes.object,
  styles: PropTypes.object,
};

DataGrid.defaultProps = {
  data: [],
  metaData: {},
  styles: {},
};

export default DataGrid;
